<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_practice_gmb_removed".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderPracticeGmbRemoved".
 *
 * Columns in table "provider_practice_gmb_removed" available as properties of the model,
 * and there are no model relations.
 *
 * @property integer $id
 * @property integer $account_id
 * @property integer $practice_id
 * @property integer $provider_id
 * @property integer $is_read_only
 * @property integer $apply_dr_booking_url
 * @property integer $apply_dr_description
 * @property integer $has_sync_issues
 * @property string $sync_issues_details
 * @property integer $has_localposts_api
 * @property string $is_claimed_by
 * @property string $escalation
 * @property string $location_name_override
 * @property string $date_added
 * @property string $date_updated
 * @property string $date_last_sync
 * @property integer $provider_practice_listing_id
 * @property integer $added_by_account_id
 * @property integer $updated_by_account_id
 * @property string $place_id
 * @property string $category_1
 * @property string $category_2
 * @property string $category_3
 * @property integer $link_verified
 * @property integer $sync_tracking_number
 * @property integer $sync_cover
 * @property integer $sync_address
 * @property integer $sync_website
 * @property integer $skip
 * @property integer $create
 * @property integer $merge
 * @property integer $close
 * @property integer $verify
 * @property integer $claim
 * @property integer $request_ownership
 * @property integer $integrate
 *
 */
abstract class BaseProviderPracticeGmbRemoved extends BaseModel
{
    public $organization_name;
    public $organization_id;

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_practice_gmb_removed';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderPracticeGmbRemoved|ProviderPracticeGmbRemoveds', $n);
    }

    public static function representingColumn()
    {
        return 'is_claimed_by';
    }

    public function rules()
    {
        return array(
            array('id, account_id, practice_id, date_added, date_updated, added_by_account_id', 'required'),
            array('id, account_id, practice_id, provider_id, is_read_only, apply_dr_booking_url, apply_dr_description, has_sync_issues, has_localposts_api, provider_practice_listing_id, added_by_account_id, updated_by_account_id, link_verified, sync_tracking_number, sync_cover, sync_address, sync_website, skip, create, merge, close, verify, claim, request_ownership, integrate', 'numerical', 'integerOnly' => true),
            array('is_claimed_by', 'length', 'max' => 8),
            array('escalation', 'length', 'max' => 2),
            array('location_name_override', 'length', 'max' => 150),
            array('place_id', 'length', 'max' => 30),
            array('category_1, category_2, category_3', 'length', 'max' => 50),
            array('sync_issues_details, date_last_sync', 'safe'),
            array('provider_id, is_read_only, apply_dr_booking_url, apply_dr_description, has_sync_issues, sync_issues_details, has_localposts_api, is_claimed_by, escalation, location_name_override, date_last_sync, provider_practice_listing_id, updated_by_account_id, place_id, category_1, category_2, category_3, link_verified, sync_tracking_number, sync_cover, sync_address, sync_website, skip, create, merge, close, verify, claim, request_ownership, integrate', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, account_id, practice_id, provider_id, is_read_only, apply_dr_booking_url, apply_dr_description, has_sync_issues, sync_issues_details, has_localposts_api, is_claimed_by, escalation, location_name_override, date_added, date_updated, date_last_sync, provider_practice_listing_id, added_by_account_id, updated_by_account_id, place_id, category_1, category_2, category_3, link_verified, sync_tracking_number, sync_cover, sync_address, sync_website, skip, create, merge, close, verify, claim, request_ownership, integrate, organization_id, organization_name', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'account' => array(self::BELONGS_TO, 'Account', 'account_id'),
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
        );
    }

    public function pivotModels()
    {
        return array();
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'account_id' => Yii::t('app', 'Account'),
            'practice_id' => Yii::t('app', 'Practice'),
            'provider_id' => Yii::t('app', 'Provider'),
            'is_read_only' => Yii::t('app', 'Is Read Only'),
            'apply_dr_booking_url' => Yii::t('app', 'Apply Dr Booking Url'),
            'apply_dr_description' => Yii::t('app', 'Apply Dr Description'),
            'has_sync_issues' => Yii::t('app', 'Has Sync Issues'),
            'sync_issues_details' => Yii::t('app', 'Sync Issues Details'),
            'has_localposts_api' => Yii::t('app', 'Has Localposts Api'),
            'is_claimed_by' => Yii::t('app', 'Is Claimed By'),
            'escalation' => Yii::t('app', 'Escalation'),
            'location_name_override' => Yii::t('app', 'Location Name Override'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'date_last_sync' => Yii::t('app', 'Date Last Sync'),
            'provider_practice_listing_id' => Yii::t('app', 'Provider Practice Listing'),
            'added_by_account_id' => Yii::t('app', 'Added By Account'),
            'updated_by_account_id' => Yii::t('app', 'Updated By Account'),
            'place_id' => Yii::t('app', 'Place'),
            'category_1' => Yii::t('app', 'Category 1'),
            'category_2' => Yii::t('app', 'Category 2'),
            'category_3' => Yii::t('app', 'Category 3'),
            'link_verified' => Yii::t('app', 'Link Verified'),
            'sync_tracking_number' => Yii::t('app', 'Sync Tracking Number'),
            'sync_cover' => Yii::t('app', 'Sync Cover'),
            'sync_address' => Yii::t('app', 'Sync Address'),
            'sync_website' => Yii::t('app', 'Sync Website'),
            'skip' => Yii::t('app', 'Skip'),
            'create' => Yii::t('app', 'Create'),
            'merge' => Yii::t('app', 'Merge'),
            'close' => Yii::t('app', 'Close'),
            'verify' => Yii::t('app', 'Verify'),
            'claim' => Yii::t('app', 'Claim'),
            'request_ownership' => Yii::t('app', 'Request Ownership'),
            'integrate' => Yii::t('app', 'Integrate'),
        );
    }

    public function search()
    {
        $filters = Yii::app()->request->getParam('filters', array());

        $criteria = new CDbCriteria;

        $criteria->select = "t.*, o.organization_name, o.id as organization_id";
        $criteria->join = "JOIN organization_account as oa ON t.account_id = oa.account_id JOIN organization as o ON oa.organization_id = o.id AND o.status='A' ";

        $criteria->compare('t.id', $this->id);
        $criteria->compare('t.account_id', $this->account_id);
        $criteria->compare('t.practice_id', $this->practice_id);
        $criteria->compare('t.provider_id', $this->provider_id);
        $criteria->compare('t.is_read_only', $this->is_read_only);
        $criteria->compare('t.apply_dr_booking_url', $this->apply_dr_booking_url);
        $criteria->compare('t.apply_dr_description', $this->apply_dr_description);
        $criteria->compare('t.has_sync_issues', $this->has_sync_issues);
        $criteria->compare('t.sync_issues_details', $this->sync_issues_details, true);
        $criteria->compare('t.has_localposts_api', $this->has_localposts_api);
        $criteria->compare('t.is_claimed_by', $this->is_claimed_by, true);
        $criteria->compare('t.escalation', $this->escalation, true);
        $criteria->compare('t.location_name_override', $this->location_name_override, true);
        $criteria->compare('t.date_added', $this->date_added, true);
        $criteria->compare('t.date_updated', $this->date_updated, true);
        $criteria->compare('t.date_last_sync', $this->date_last_sync, true);
        $criteria->compare('t.provider_practice_listing_id', $this->provider_practice_listing_id);
        $criteria->compare('t.added_by_account_id', $this->added_by_account_id);
        $criteria->compare('t.updated_by_account_id', $this->updated_by_account_id);
        $criteria->compare('t.place_id', $this->place_id, true);
        $criteria->compare('t.category_1', $this->category_1, true);
        $criteria->compare('t.category_2', $this->category_2, true);
        $criteria->compare('t.category_3', $this->category_3, true);
        $criteria->compare('t.link_verified', $this->link_verified);
        $criteria->compare('t.sync_tracking_number', $this->sync_tracking_number);
        $criteria->compare('t.sync_cover', $this->sync_cover);
        $criteria->compare('t.sync_address', $this->sync_address);
        $criteria->compare('t.sync_website', $this->sync_website);
        $criteria->compare('t.skip', $this->skip);
        $criteria->compare('t.create', $this->create);
        $criteria->compare('t.merge', $this->merge);
        $criteria->compare('t.close', $this->close);
        $criteria->compare('t.verify', $this->verify);
        $criteria->compare('t.claim', $this->claim);
        $criteria->compare('t.request_ownership', $this->request_ownership);
        $criteria->compare('t.integrate', $this->integrate);
        $criteria->compare('o.id', $this->organization_id);
        $criteria->compare('o.organization_name', $this->organization_name, true);

        $criteria = $this->buildAdvanceSearchCriteria($criteria, $filters);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

    private function buildAdvanceSearchCriteria($criteria, $filters)
    {
        if (!empty($filters)) {

            // filter for date_added
            if (!empty($filters['date_added'])) {
                if ($filters['date_added'] == "today") {
                    $criteria->compare('DATE(t.date_added)', date('Y-m-d'), true);
                } elseif ($filters['date_added'] == "7days") {
                    $to_date = date('Y-m-d');
                    $from_date = date('Y-m-d', strtotime($to_date . ' - 7 days'));
                    $criteria->addBetweenCondition('DATE(t.date_added)', $from_date, $to_date, 'AND');
                } elseif ($filters['date_added'] == "30days") {
                    $to_date = date('Y-m-d');
                    $from_date = date('Y-m-d', strtotime($to_date . ' - 30 days'));
                    $criteria->addBetweenCondition('DATE(t.date_added)', $from_date, $to_date, 'AND');
                } elseif ($filters['date_added'] == "1year") {
                    $to_date = date('Y-m-d');
                    $from_date = date('Y-m-d', strtotime($to_date . ' - 1 years'));
                    $criteria->addBetweenCondition('DATE(t.date_added)', $from_date, $to_date, 'AND');
                } elseif ($filters['date_added'] == "90days") {
                    $to_date = date('Y-m-d');
                    $from_date = date('Y-m-d', strtotime($to_date . ' - 90 days'));
                    $criteria->addBetweenCondition('DATE(t.date_added)', $from_date, $to_date, 'AND');
                } elseif ($filters['date_added'] == "custom") {
                    $from_date = date('Y-m-d', strtotime($filters['date_added_from']));
                    $to_date = date('Y-m-d', strtotime($filters['date_added_to']));
                    $criteria->addBetweenCondition('DATE(t.date_added)', $from_date, $to_date, 'AND');
                }
            }

            // filter for date_updated
            if (!empty($filters['date_updated'])) {
                if ($filters['date_updated'] == "today") {
                    $criteria->compare('DATE(t.date_updated)', date('Y-m-d'), true);
                } elseif ($filters['date_updated'] == "7days") {
                    $to_date = date('Y-m-d');
                    $from_date = date('Y-m-d', strtotime($to_date . ' - 7 days'));
                    $criteria->addBetweenCondition('DATE(t.date_updated)', $from_date, $to_date, 'AND');
                } elseif ($filters['date_updated'] == "30days") {
                    $to_date = date('Y-m-d');
                    $from_date = date('Y-m-d', strtotime($to_date . ' - 30 days'));
                    $criteria->addBetweenCondition('DATE(t.date_updated)', $from_date, $to_date, 'AND');
                } elseif ($filters['date_updated'] == "90days") {
                    $to_date = date('Y-m-d');
                    $from_date = date('Y-m-d', strtotime($to_date . ' - 90 days'));
                    $criteria->addBetweenCondition('DATE(t.date_updated)', $from_date, $to_date, 'AND');
                } elseif ($filters['date_updated'] == "1year") {
                    $to_date = date('Y-m-d');
                    $from_date = date('Y-m-d', strtotime($to_date . ' - 1 years'));
                    $criteria->addBetweenCondition('DATE(t.date_updated)', $from_date, $to_date, 'AND');
                } elseif ($filters['date_updated'] == "custom") {
                    $from_date = date('Y-m-d', strtotime($filters['date_updated_from']));
                    $to_date = date('Y-m-d', strtotime($filters['date_updated_to']));
                    $criteria->addBetweenCondition('DATE(t.date_updated)', $from_date, $to_date, 'AND');
                }
            }

            // filter for date_last_sync
            if (!empty($filters['date_last_sync'])) {
                if ($filters['date_last_sync'] == "today") {
                    $criteria->compare('DATE(t.date_last_sync)', date('Y-m-d'), true);
                } elseif ($filters['date_last_sync'] == "7days") {
                    $to_date = date('Y-m-d');
                    $from_date = date('Y-m-d', strtotime($to_date . ' - 7 days'));
                    $criteria->addBetweenCondition('DATE(t.date_last_sync)', $from_date, $to_date, 'AND');
                } elseif ($filters['date_last_sync'] == "30days") {
                    $to_date = date('Y-m-d');
                    $from_date = date('Y-m-d', strtotime($to_date . ' - 30 days'));
                    $criteria->addBetweenCondition('DATE(t.date_last_sync)', $from_date, $to_date, 'AND');
                } elseif ($filters['date_last_sync'] == "90days") {
                    $to_date = date('Y-m-d');
                    $from_date = date('Y-m-d', strtotime($to_date . ' - 90 days'));
                    $criteria->addBetweenCondition('DATE(t.date_last_sync)', $from_date, $to_date, 'AND');
                } elseif ($filters['date_last_sync'] == "1year") {
                    $to_date = date('Y-m-d');
                    $from_date = date('Y-m-d', strtotime($to_date . ' - 1 years'));
                    $criteria->addBetweenCondition('DATE(t.date_last_sync)', $from_date, $to_date, 'AND');
                } elseif ($filters['date_last_sync'] == "custom") {
                    $from_date = date('Y-m-d', strtotime($filters['date_last_sync_from']));
                    $to_date = date('Y-m-d', strtotime($filters['date_last_sync_to']));
                    $criteria->addBetweenCondition('DATE(t.date_last_sync)', $from_date, $to_date, 'AND');
                }
            }
        }
        return  $criteria;
    }
}
